package com.trs.ggzyexchange.schedul;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.trs.ggzyexchange.api.vo.Result;
import com.trs.ggzyexchange.controller.BaseController;
import com.trs.ggzyexchange.entity.GcNoticeandfile;
import com.trs.ggzyexchange.entity.GcPerformance;
import com.trs.ggzyexchange.entity.ScheduledTash;
import com.trs.ggzyexchange.entity.TenderDetailsVo;
import com.trs.ggzyexchange.enums.ClassIfy;
import com.trs.ggzyexchange.enums.JobLock;
import com.trs.ggzyexchange.service.GcNoticeandfileService;
import com.trs.ggzyexchange.service.GcPerformanceService;
import com.trs.ggzyexchange.service.ScheduledTashService;
import com.trs.ggzyexchange.service.TenderDetailsVoService;
import com.trs.ggzyexchange.utils.TenderDetailsVoUtils;
import org.apache.commons.lang3.ObjectUtils;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * <p>
 * 合同履约 前端控制器
 * </p>
 *
 * @author trs
 * @since 2023-03-03
 */
@Component
public class GcPerformanceSchedul  implements Job {

    private Logger logger = LoggerFactory.getLogger(GcPerformanceSchedul.class);

    @Autowired
    private GcPerformanceService gcPerformanceService;

    @Autowired
    private TenderDetailsVoService tenderDetailsVoService;

    @Autowired
    private GcNoticeandfileService gcNoticeandfileService;

    @Autowired
    private ScheduledTashService scheduledTashService;

    public void queryPageListUpdateEs() throws JsonProcessingException {

        //查询当前在定时任务表当中的时间
        QueryWrapper<ScheduledTash> scheduledTashQueryWrapper = new QueryWrapper<ScheduledTash>();
        scheduledTashQueryWrapper.eq("table_name_value","gc_performance");
        Page<ScheduledTash> pageScheduledTash = new Page<ScheduledTash>(1, 1);
        Page<ScheduledTash> page = scheduledTashService.page(pageScheduledTash, scheduledTashQueryWrapper);
        List<ScheduledTash> records = page.getRecords();
        ScheduledTash scheduledTash = null;
        if(records.size() > 0){
            scheduledTash = records.get(0);
        }
        Long time = null;
        if(ObjectUtils.isEmpty(scheduledTash)){
            try {
                //查询表gcNoticeandfile表当中的最新时间
                time = gcPerformanceService.maxDataTimeStamp();
                ScheduledTash scheduledTashTash = new ScheduledTash();
                scheduledTashTash.setTime(time);
                scheduledTashTash.setTableNameValue("gc_performance");
                scheduledTashTash.setUpdateTime(new Date());
                scheduledTashTash.setCreateTime(new Date());
                scheduledTashService.saveOrUpdate(scheduledTashTash,scheduledTashQueryWrapper);
            }catch (Exception e){
                e.printStackTrace();
            }
        }else {
            time = scheduledTash.getTime();
        }
        try {
            //查询表gcNoticeandfile表当中的最新时间
            Long newTime = gcPerformanceService.maxDataTimeStamp();
            ScheduledTash scheduledTashTash = new ScheduledTash();
            scheduledTashTash.setTime(newTime);
            scheduledTashTash.setTableNameValue("gc_performance");
            scheduledTashTash.setUpdateTime(new Date());
            scheduledTashService.saveOrUpdate(scheduledTashTash,scheduledTashQueryWrapper);
        }catch (Exception e){
            e.printStackTrace();
        }

        if(!ObjectUtils.isEmpty(time)){
            try {
                QueryWrapper<GcPerformance> gcPerformanceQueryWrapper = new QueryWrapper<GcPerformance>();
                gcPerformanceQueryWrapper.gt("DATA_TIMESTAMP",time);
                int count = gcPerformanceService.count(gcPerformanceQueryWrapper);
                Integer pageSize = 1000;
                Integer pageNum = (int)Math.ceil((double)count/pageSize);
                List<TenderDetailsVo> tenderDetailsVos = new ArrayList<TenderDetailsVo>();
                for(int i = 1; i <= pageNum;i++){
                   try {
                       List<TenderDetailsVo> tenderDetailsVoListAll = getTenderDetailsVoListAll(i, pageSize,time);
                       Boolean aBoolean = gcNoticeandfileService.parseTenderDetailsVo(tenderDetailsVoListAll);
                   }catch (Exception e){
                       e.printStackTrace();
                   }
                }
            }catch (Exception e){
                e.printStackTrace();
            }
        }
    }
    public List<TenderDetailsVo> getTenderDetailsVoListAll(Integer pageNo,Integer pageSize,Long time){
        Page<GcPerformance> page = new Page<GcPerformance>(pageNo, pageSize);
        IPage<TenderDetailsVo> tenderDetailsVoIPage = gcPerformanceService.queryGcBidcandidateAllListByTime(page,time);
        for (TenderDetailsVo record : tenderDetailsVoIPage.getRecords()) {
            try {
                record.setNoticeTypeCode(ClassIfy.PERFORMANCE_PUBLICITY.getCode());
                record.setNoticeTypeName(ClassIfy.PERFORMANCE_PUBLICITY.getName());
                record.setTransactionTypeCode(ClassIfy.ENGINEERING_CONSTRUCTION.getCode());
                record.setTransactionTypeName(ClassIfy.ENGINEERING_CONSTRUCTION.getName());
                record = tenderDetailsVoService.getTenderDetailsVoAllOrther(record);
                TenderDetailsVoUtils.isNull(record);
            }catch (Exception e){
                e.printStackTrace();
            }
        }
        return tenderDetailsVoIPage.getRecords();
    }

    @Override
    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {
        try {
            if(JobLock.GcPerformanceFlag){
                JobLock.GcPerformanceFlag = false;
                logger.info("执行GcPerformance", new SimpleDateFormat().format(new Date()));
                try {
                    queryPageListUpdateEs();
                } catch (Exception e) {
                    e.printStackTrace();
                }
                JobLock.GcPerformanceFlag = true;
            }else{
                logger.info("不执行GcPerformance", new SimpleDateFormat().format(new Date()));
            }
        }catch (Exception e){
            e.printStackTrace();
        }
    }
}
